'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.connectionDefault = exports.connectionATNA = exports.connectionAPI = exports.connectionAgenda = undefined;

var _mongoose = require('mongoose');

var _mongoose2 = _interopRequireDefault(_mongoose);

var _mongodbUri = require('mongodb-uri');

var _mongodbUri2 = _interopRequireDefault(_mongodbUri);

var _ = require('./');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_.config.mongo = _.config.get('mongo');

_mongoose2.default.set('useNewUrlParser', true);

const connectionAgenda = exports.connectionAgenda = _mongoose2.default.createConnection(encodeMongoURI(_.config.mongo.url));
const connectionAPI = exports.connectionAPI = _mongoose2.default.createConnection(encodeMongoURI(_.config.mongo.url), getMongoOptions());
const connectionATNA = exports.connectionATNA = _mongoose2.default.createConnection(encodeMongoURI(_.config.mongo.atnaUrl));
const connectionDefault = exports.connectionDefault = _mongoose2.default.createConnection(encodeMongoURI(_.config.mongo.url));

function encodeMongoURI(urlString) {
  if (urlString) {
    let parsed = _mongodbUri2.default.parse(urlString);
    urlString = _mongodbUri2.default.format(parsed);
  }
  return urlString;
}

function getMongoOptions() {
  return {
    readPreference: _.config.mongo.openHIMApiReadPreference,
    readConcern: { level: _.config.mongo.openHIMApiReadConcern },
    w: _.config.mongo.openHIMApiWriteConcern
  };
}

if (process.env.NODE_ENV === 'test') {
  exports.encodeMongoURI = encodeMongoURI;
}
//# sourceMappingURL=connection.js.map