'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setupProxyHeaders = setupProxyHeaders;
exports.koaMiddleware = koaMiddleware;

var _config = require('../config');

function setupProxyHeaders(ctx) {
  // Headers
  function setOrAppendHeader(ctx, header, value) {
    if (!value) {
      return;
    }
    if (ctx.header[header]) {
      ctx.header[header] = `${ctx.header[header]}, ${value}`;
    } else {
      ctx.header[header] = `${value}`;
    }
  }

  setOrAppendHeader(ctx, 'X-Forwarded-For', ctx.request.ip);
  return setOrAppendHeader(ctx, 'X-Forwarded-Host', ctx.request.host);
}

async function koaMiddleware(ctx, next) {
  exports.setupProxyHeaders(ctx);
  await next();
}
//# sourceMappingURL=proxy.js.map