'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.authenticateUser = authenticateUser;
exports.koaMiddleware = koaMiddleware;

var _clients = require('../model/clients');

var _config = require('../config');

var _util = require('util');

const dummyClient = new _clients.ClientModel({
  clientID: 'DUMMY-TCP-USER',
  clientDomain: 'openhim.org',
  name: 'DUMMY-TCP-USER',
  roles: ['tcp']
});

function authenticateUser(ctx, done) {
  ctx.authenticated = dummyClient;
  return done(null, dummyClient);
}

/*
 * Koa middleware for bypassing authentication for tcp requests
 */
async function koaMiddleware(ctx, next) {
  const _authenticateUser = (0, _util.promisify)(authenticateUser);
  await _authenticateUser(ctx);

  if (ctx.authenticated != null) {
    await next();
  } else {
    ctx.response.status = 401;
  }
}
//# sourceMappingURL=tcpBypassAuthentication.js.map